/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("jazz.ui.ImagePreview");

dojo.require("jazz.ui.HoverPopup");

(function() {

/*
 * PROVISIONAL: This API is considered provisional and may be changed or removed in the
 * future with minimal or no warning.
 * 
 * @since 0.7
 */
dojo.declare("jazz.ui.ImagePreview", jazz.ui.HoverPopup, {

	customClass: "jazz-ui-ImagePreview",

	createContents: function(tip) {
		var root = document.createElement("div");
		var div = document.createElement("div");
		var open = document.createElement("a");
		open.href = this.src;
		open.target = "_new";
		open.innerHTML = "Open";
		div.appendChild(open);
		div.appendChild(document.createTextNode(" | " + this.filename));
		this._contentArea = document.createElement("div")
		this._contentArea.appendChild(document.createTextNode("loading..."));
		root.appendChild(div);
		root.appendChild(this._contentArea);
		this._imageTag = document.createElement("img");
		this._imageTag.src = this.src;
		this.managedConnect(this._imageTag, "onclick", this, this.close);
		this.poll();
		return root;
	},
	
	poll: function() {
		if (this._imageTag.complete) {
			var div = document.createElement("div");
			div.style.position = "absolute";
			div.style.visibility = "hidden";
			div.style.left = "-1000px";
			div.style.top = "0";
			div.appendChild(this._imageTag);
			document.body.appendChild(div);
			var width = div.clientWidth;
			var height = div.clientHeight;
			document.body.removeChild(div);
			div.removeChild(this._imageTag);
			this._contentArea.style.width = width + "px";
			this._contentArea.style.height = height + "px";
			if (this._contentArea.firstChild) {
				this._contentArea.replaceChild(this._imageTag, this._contentArea.firstChild);
				while (this._contentArea.firstChild.nextSibling) 
					this._contentArea.removeChild(this._contentArea.firstChild.nextSibling);
			}
			else {
				this._contentArea.appendChild(this._imageTag);
			}
			this.position(this._target);
		}
		else 
			setTimeout(dojo.hitch(this, this.poll), 200);
	},
	
	updateDimensions: function(v) {
		this.maxWidth = parseInt(v.w * 0.8);
		this.maxHeight = parseInt(v.h * 0.8);
	}

});

})();
