/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("jazz.app.internal.HoverMenu");

dojo.declare("jazz.app.internal.HoverMenu", [dijit._Widget], {
	
	align: "left",
	around: "",
	menuProvider: null,
	showCaret: true,
	buttonMenuOpenClass: "menu-open",
	menuClass: "",
	href: "",

	postCreate: function() {
		dojo.addClass(this.domNode,"jazz-app-HoverMenu");
		var self = this;
		this.connect(this.domNode,"onmouseover",function(event){
			dojo.stopEvent(event);
			if (self._mouseOutEvent) return;
			if (!self._overTimeout) {
				self._overTimeout = setTimeout(dojo.hitch(self,self._mouseOver),400);	
			}
			self._currentButton = self.domNode;
			self._mouseOutEvent = self.connect(dojo.doc, "onmousemove", self._mouseOut);
		});
		this.connect(this.domNode,"onkeypress", this._handleKeypress);
		var caret = document.createElement("img");
		caret.className = "caret";
		caret.src = dojo.moduleUrl("jazz.app", "graphics/HoverMenu/caret.png");
		this.domNode.appendChild(caret);
	},
	_mouseOver: function() {
		clearTimeout(this._overTimeout);
		this._overTimeout = null;
		if (this._bodyEvent) return;
		var node = this.around ? this.around : this.domNode;
		if (this._currentMenu) this._killMenu();
		if (this.menuProvider) {
			var menu = this.menuProvider(this);	
		}
		dojo.addClass(menu.domNode, "jazz-app-HoverMenu-menu");
		dojo.addClass(menu.domNode, this.menuClass);
		var orient = (this.align == "right") ? {"BR":"TR"}: {"BL":"TL"};
		dijit.popup.open({popup: menu, parent: this, around: node, orient: orient, onExecute: dojo.hitch(this,this._killMenu), onCancel: dojo.hitch(this,this._killMenu)});
		if (menu.focus) {
			menu.focus();	
		}
		this._currentMenu = menu;
		this._currentButton = node;
		dojo.addClass(node,this.buttonMenuOpenClass);
		var self = this;
		this._bodyEvent = this.connect(document.body, "onclick", function(event){
			if (dojo.isDescendant(event.target, self._currentButton) || dojo.isDescendant(event.target, self._currentMenu.domNode)) {
				return;
			}
			self._killMenu();
		});
	},
	_mouseOut: function(event) {
		if (dojo.isDescendant(event.target, this._currentButton) || (this._currentMenu && dojo.isDescendant(event.target, this._currentMenu.domNode))) {
			clearTimeout(this._timeout);
			this._timeout = null;
			return;	
		}  else {
			if (this._overTimeout) {
				clearTimeout(this._overTimeout);
				this.disconnect(this._mouseOutEvent);
				this._overTimeout = null;
				this._mouseOutEvent = null;
				return;	
			}
		}
		if (!this._timeout) {
			this._timeout = setTimeout(dojo.hitch(this,this._killMenu), 300);	
		}
	},
	// private functions
	_killMenu: function() {
		if (this._currentMenu) {
			dijit.popup.close(this._currentMenu);
			if (this._currentMenu && this._currentMenu.destroy) {
				this._currentMenu.destroy();	
			}
			var node = this.around ? this.around : this.domNode;
			dojo.removeClass(node,this.buttonMenuOpenClass);
			this.disconnect(this._mouseOutEvent);
			this.disconnect(this._bodyEvent);
			this._currentMenu = null
			this._currentButton = null;
			this._mouseOutEvent = null;
			this._bodyEvent = null;
		}	
	},
	_handleKeypress: function(e) {
		var k = dojo.keys;
		switch (e.charOrCode) {
			case k.DOWN_ARROW:
				this._mouseOver();
				break;
			case k.SPACE:
				this._mouseOver();
				break;
		}
	}
});

})();