/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.repository.web.ui.internal.admin.users.PasswordChangeDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.TextBox");
dojo.require("dojox.data.dom");
dojo.require("dojo.i18n");
dojo.require("dojo.string");

dojo.requireLocalization("com.ibm.team.repository.web.ui.internal.admin.users", "PasswordChangeDialogMessages");

(function() {
	
dojo.declare("com.ibm.team.repository.web.ui.internal.admin.users.PasswordChangeDialog", [dijit._Widget, dijit._Templated], {
		
	templatePath: dojo.moduleUrl("com.ibm.team.repository.web", "ui/internal/admin/users/templates/PasswordChangeDialog.html"),
	widgetsInTemplate: true,
	
	constructor: function (args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.repository.web.ui.internal.admin.users", "PasswordChangeDialogMessages");
		this.itemId = args.itemId;
		this.userId = args.userId;
		this.userName = args.userName;
		if (this.userName != null && this.userName != "") {
			this.dialogHeadingMsg = dojo.string.substitute(this.messages.dialogHeading, [ this.userName ]);
		} else {
			this.dialogHeadingMsg = this.messages.changePassword;
		}
	},
	
	postCreate: function () {
		this.dialog = new jazz.ui.Dialog({
			contentNode: this.contentNode,
			primaryTitle: this.messages.changePassword,
			// FF can autosize the dialog but IE can't
			width: dojo.isIE ? "25em" : "" //$NON-NLS-1$
		});
	},
	
	showErrorMessage: function (msg) {
		this.messageArea.className = "error";
		dojox.data.dom.removeChildren(this.messageArea);
		this.messageArea.appendChild(document.createTextNode(msg));
	},
	
	close: function () {
		this.dialog.close();
	}
});

})();