/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("net.jazz.ajax.service.ui.internal.userdata.ManageFavorites");

dojo.require("net.jazz.ajax.ui.MappingUI");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("net.jazz.ajax.ui.Workbench");
dojo.require("net.jazz.ajax.service.ui.userdata.util");
dojo.require("net.jazz.ajax.service.ui.internal.userdata.UserDataManager");

dojo.require("jazz.client.xhr");

var PlatformUI = net.jazz.ajax.ui.PlatformUI;

dojo.declare("net.jazz.ajax.service.ui.internal.userdata.ManageFavorites", [net.jazz.ajax.service.ui.internal.userdata.UserDataManager], {
	constructor: function (args) {
		this._dataType = "Favorites";
		this._EDITOR = "net.jazz.ajax.EditFavorite";
	},
	
	postCreate: function() {
		this.inherited(arguments);
		this.connect(this.deleteButton, "onclick", function (e) {
			this.deleteButton.disabled = true;
			this.deleteButton.rowsPendingDeletion = this.getSelectedRows();
			var removeFavs = this.getSelectedUris();
			var dfd = net.jazz.ajax.service.ui.userdata.util.removeFavorites(removeFavs);
			if (dfd != null) {
				dfd.addCallback(dojo.hitch(this, function() {
					for (var i = 0; i < this.deleteButton.rowsPendingDeletion.length; i++) {
						this.userDataTable.removeChild(this.deleteButton.rowsPendingDeletion[i]);
					}
				}));
				dfd.addBoth(dojo.hitch(this, function () {
					this.deleteButton.rowsPendingDeletion = [];
					this.deleteButton.disabled = false;
				}));
			} else {
				this.deleteButton.rowsPendingDeletion = [];
				this.deleteButton.disabled = false;
			}			
		});
		this.connect(this.searchButton, "onclick", function (e) {
			var dfd = net.jazz.ajax.service.ui.userdata.util.getFavorites(this.searchText.value);
			if (dfd) {
				dfd.addCallback(dojo.hitch(this, this.favoritesCallback));
				dfd.addErrback(dojo.hitch(this, this.favoritesErrback));
			} else {
				this.populate();
			}
		});
		
		var dfd = net.jazz.ajax.service.ui.userdata.util.getFavorites();
		if (dfd) {
			dfd.addCallback(dojo.hitch(this, this.favoritesCallback));
			dfd.addErrback(dojo.hitch(this, this.favoritesErrback));
		} else {
			this.populate();
		}		
	},
	
	favoritesCallback: function (response) {
		this.processResponse(response, "group:favorite");
	},
	
	favoritesErrback: function (err) {
		this.processResponseErr(err, "favorites");
	}
});
})();